#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <ogcsys.h>
#include <gccore.h>
#include <gctypes.h>
#include <stdarg.h>
#include <ctype.h>
#include <math.h>
#include <unistd.h>
#include <ogc/isfs.h>
#include <wiiuse/wpad.h>

#include "certs_bin.h"
#include "tmd_bin.h"
#include "ticket_bin.h"
#include "patch.h"
#include "patches.h"
#define round_up(x,n) (-(-(x) & -(n))) 

 u64 *titles = NULL;
 u32 num_titles=0; 
 int ios_index=0; 
 u8 ios_found[256];
 int get_title_list()

  {          
  u32 len_buf;
      s32 ret; 
     int n; 
       memset((void *) ios_found,0, 256); 
       ret = ES_GetNumTitles(&num_titles); 
     if (ret < 0) 
         return ret; 
       if(num_titles<1) return -1;
        len_buf = round_up((num_titles+1) * sizeof(u64), 32); 
       titles = memalign(32, len_buf);
      if (!titles)
          return -1;
          ret = ES_GetTitles(titles, num_titles); 
     if (ret < 0)
          goto err;
        n=0; 
     while(n<num_titles) 
     { 
     u32 tidh = (titles[n] >> 32);
      u32 tidl = (titles[n] &  0xFFFFFFFF); 
       if ((tidh != 0x1) || (tidl < 3) || (tidl > 255))

          { 
         num_titles--; 
         memcpy(&titles[n],&titles[n+1], (num_titles-n) * sizeof(u64));
          }           
		  else
               {ios_found[tidl]=1;n++;} 
     }        
			   return 0;
    err:  
          if (titles) free(titles);
 titles = NULL;
        return ret; 
   }


static void *xfb = NULL;
static GXRModeObj *rmode = NULL;
s32 ret, fd;
u32 len;
void *buffer;
const char *filename = "/title/00000001/00000002/content/0000008e.app";
const char *err = "Error: %d.\n\n";

int load_menu() {
		ret = __ES_Init();
	if (ret < 0) {
		printf("Es_Initalize Error");
		printf(err, ret);
		return ret;
	}
	ret = ES_Identify((signed_blob *)certs_bin, certs_bin_size, (signed_blob *)tmd_bin, tmd_bin_size, (signed_blob *)ticket_bin, ticket_bin_size, NULL);
	if (ret < 0) {
		printf("Es_Identify Error");
		printf(err, ret);
		return ret;
	}
	ret = ISFS_Initialize();
	if (ret < 0) {
		printf("ISFS_Initalize Error");
		printf(err, ret);
		return ret;
	}
	fd	= ISFS_Open(filename, (u8)ISFS_OPEN_READ);
	if (fd < 0) {
	printf("ISFS Open Error");
	printf(err, fd);
		return fd; 	
	}
	fstats *fs;
	ret = ISFS_GetFileStats(fd, fs);
	if (ret < 0) {
		printf("ISFS Get FileStats Error");
		printf(err, ret);
		return ret;
	}
	len = fs->file_length;
	buffer = memalign(32, len);
	ret = ISFS_Read(fd, buffer, len);
	if (ret < 0) {
		printf("Copy Error");
		printf(err, ret);
		return ret;
	}
	ret = ISFS_Close(fd);
	if (ret < 0) {
		printf(err, ret);
		return ret;
	}
	printf("Done!\n\n");
	return 0;
}

void save_menu();
int remove_patch(patch_t *pt) {
	u8 *patch_addr;
	int test;
	patch_addr = buffer + pt->offset;
	if (memcmp(patch_addr, pt->new_tab, pt->size)) {
		printf("\x1b[2J\x1b[2;2HThe patch section was not found in the DOL. Nothing to do.\x1b[24;35HA: Continue.");
		test = 1;
			while (test) {
				WPAD_ScanPads();
				if (WPAD_ButtonsDown(0) & WPAD_BUTTON_A) test = 0;
			}
		return(-1);
	}
	printf("\x1b[2J\x1b[2;2HThe patch was found. Press A to remove.\x1b[24;28HA: Continue     B: Back");
	test = 1;
	while (test) {
		WPAD_ScanPads();
		switch (WPAD_ButtonsDown(0)) {
			case WPAD_BUTTON_A:
				test = 0;
				break;
			case WPAD_BUTTON_B:
				return -1;
				break;
		}
	}
	memcpy(patch_addr, pt->old_tab, pt->size);
	return 0;
}
int install_patch(patch_t *pt) {
	u8 *patch_addr;
	int test;
	patch_addr = buffer + pt->offset;
	if (memcmp(patch_addr, pt->old_tab, pt->size)) {
		printf("\x1b[2J\x1b[2;2HThe patch section was not found in the DOL. Nothing to do.\x1b[24;35HA: Continue.");
		test = 1;
			while (test) {
				WPAD_ScanPads();
				if (WPAD_ButtonsDown(0) & WPAD_BUTTON_A) test = 0;
			}
		return(-1);
	}
	printf("\x1b[2J\x1b[2;2HThe patch was found. Press A to apply.\x1b[24;28HA: Continue     B: Back");
	test = 1;
	while (test) {
		WPAD_ScanPads();
		switch (WPAD_ButtonsDown(0)) {
			case WPAD_BUTTON_A:
				test = 0;
				break;
			case WPAD_BUTTON_B:
				return -1;
				break;
		}
	}
	memcpy(patch_addr, pt->new_tab, pt->size);
	return 0;
}
void save_menu() {
	s32 fd;
	int test = 1;
	printf("\x1b[47m\x1b[30m\x1b[2J\x1b[2;2HNOW IS YOUR LAST CHANCE TO TURN BACK!\x1b[24;28HA: Continue     B: Back");
	while (test) {
		WPAD_ScanPads();
		switch (WPAD_ButtonsDown(0)) {
			case WPAD_BUTTON_A:
				test = 0;
				break;
			case WPAD_BUTTON_B:
				printf("\x1b[2J\x1b[2;2HReturning To Loader...");
				exit(0);
				break;
		}
	}
	printf("\x1b[2J\x1b[2;2HISFS_Open...");
	fd	= ISFS_Open(filename, (u8)ISFS_OPEN_WRITE);
	if (fd < 0) {
	printf(err, fd);
		}	
	printf("Done!\n\nWriting System Menu...");
	ret = ISFS_Write(fd, buffer, len);
	if (ret < 0) {
		printf(err, ret);
	}
	ret = ISFS_Deinitialize();
	if (ret < 0) {
		printf(err, ret);
	}
	ret = __ES_Close();
	if (ret < 0) {
		printf(err, ret);
	}
	printf("DONE! Returning To Loader...");
	exit(0);
}

void ClearScreen(void)
{
	/* Clear console */
	printf("\x1b[2J");
	fflush(stdout);
}

void reiniciar(void)
{
	printf("\n    Restarting Wii...");
	fflush(stdout);

		/* Return to the Wii system menu */
	SYS_ResetSystem(SYS_RETURNTOMENU, 0, 0);
}	

void Warning(void)
{	
ClearScreen();
	/* Print Warning */
	printf("  \n");
	printf("  \n");
	printf("  \n");
	printf("    [+] [ WARNING!!!]:\n\n");
	printf("    ----------------------------------------------------\n\n");
    printf("    |  USE ONLY ON WIIs WITH SYSMENU 4.2 Korean,       |\n");
	printf("    |  These patches are not temporary,                |\n");
	printf("    |  and can BRICK YOUR WII!                         |\n");
	printf("    |  PLEASE BE CAREFUL WITH PATCHES.H!               |\n");
	printf("    ----------------------------------------------------\n\n");
	printf("    ----------------------------------------------------\n\n");
	printf("    |  Aquilino (creator of StartPatch)                |\n");
    printf("    |  Thanks crediar for PRELOADER                    |\n");
	printf("    |  Thanks Alejandroues for USA MOD                 |\n");
	printf("    |  Thanks Wiicrazy for PATCH HEDE                  |\n");
	printf("    |  Thanks TiMeBoMb & BlackAce83 for v4.2.5 UPDATE  |\n");
	printf("    ----------------------------------------------------\n\n");
	printf("    >>   Press A Button To Continue.\n");
	printf("    >>   Press B Button To Restart Your Wii.\n");
	/* Wait for user answer */
	for (;;) {
	
	WPAD_ScanPads();
		u32 buttonsDown = WPAD_ButtonsDown(0);;

		if (buttonsDown & WPAD_BUTTON_A)
			break;

		if (buttonsDown & WPAD_BUTTON_B)
			reiniciar();
	}
}

//---------------------------------------------------------------------------------
int main(int argc, char **argv) {
//---------------------------------------------------------------------------------
	
	// Initialise the video system
	VIDEO_Init();
	
	// This function initialises the attached controllers
	WPAD_Init();
	
	// Obtain the preferred video mode from the system
	// This will correspond to the settings in the Wii menu
	rmode = VIDEO_GetPreferredMode(NULL);

	// Allocate memory for the display in the uncached region
	xfb = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));
	
	// Initialise the console, required for printf
	console_init(xfb,20,20,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth*VI_DISPLAY_PIX_SZ);
	
	// Set up the video registers with the chosen mode
	VIDEO_Configure(rmode);
	
	// Tell the video hardware where our display memory is
	VIDEO_SetNextFramebuffer(xfb);
	
	// Make the display visible
	VIDEO_SetBlack(FALSE);

	// Flush the video register changes to the hardware
	VIDEO_Flush();

	// Wait for Video setup to complete
	VIDEO_WaitVSync();
	if(rmode->viTVMode&VI_NON_INTERLACE) VIDEO_WaitVSync();
	
	s32 pressed;
    #if 1        
	
	if(get_title_list()!=0) 

     {
          printf("Error getting title listn");
          return 0;
      }  
      ios_index=36;
      if(ios_found[249]) ios_index=249;
      else      
	  if(ios_found[250]) ios_index=250;
      else      
	  if(ios_found[222]) ios_index=222;
      else      
	  if(ios_found[223]) ios_index=223;
      else      
	  if(ios_found[35]) ios_index=35;
            while(!ios_found[ios_index]) {ios_index++;if(ios_index>255) ios_index=0;}
                    
					while(1)      
					
					{ 
	printf("\x1b[3J\x1b[2;2HStartPatch V4.2.5\n");
    printf("  Selected IOS for  StartPatch <%i>\n", ios_index);
    printf("  Press LEFT/RIGHT to select other different IOS\n"); 
    printf("  Press A to continue (TAKE THE RISK).\n");
    printf("  Press B to abort.\n");
	
            WPAD_ScanPads();
          pressed = WPAD_ButtonsDown(0);
            
			if(pressed) 
			
			{  

            if (pressed == WPAD_BUTTON_A) { 
                 break;              
				 }           
				 if (pressed == WPAD_BUTTON_B) {                  
				 printf("Aborted, exiting...\n");                 
 return 0;              
 }          
 if (pressed == WPAD_BUTTON_RIGHT)              
 {              
 do{ios_index++;if(ios_index>255) ios_index=0;} while(!ios_found[ios_index]);             
 }          
 if (pressed == WPAD_BUTTON_LEFT)
              
			  {              
			  do{ios_index--;if(ios_index<0) ios_index=255;} while(!ios_found[ios_index]);  
 }          
 }         
	VIDEO_WaitVSync();	
 }  
 
 #endif        
 WPAD_Shutdown();      
 sleep(1);      
 IOS_ReloadIOS(ios_index);      
 sleep(1);        
 WPAD_Init();      
 
	int i, init, install, option = 0;
	init = load_menu();
	if (init < 0) {
		printf("Returning To Loader...");
		sleep(2);
		exit(0);
	}
	ClearScreen();
	Warning();	
	// The console understands VT terminal escape codes
	// This positions the cursor on row 2, column 0
	// we can use variables for this with format codes too
	// e.g. printf ("\x1b[%d;%dH", row, column );
	printf("\x1b[2;0H");
	
	while(1) {

		printf("\x1b[40m\x1b[2J\x1b[2;22H\x1b[33mStartPatch V4.2.5K\n");
		int space = 25/(PATCH_COUNT+1), patch = 1;
		for (i = 0; i < PATCH_COUNT; i++) {
			printf("\x1b[%d;20HInstall Patch - %s", (space * i) + 4, ptch[i].desc);
		}
		printf("\x1b[%d;20HSave", (space * PATCH_COUNT) + 4);
		printf("\x1b[%d;20HExit", (space * PATCH_COUNT+1) + 4);
		printf("\x1b[%d;17HA: Install   B: Unistall   HOME: Exit To Loader", (space * PATCH_COUNT+5) + 4);
		printf("\x1b[%d;17H*", (space * option) + 4);
                 

		while(patch) {

			// Call WPAD_ScanPads each loop, this reads the latest controller states
			WPAD_ScanPads();

			// WPAD_ButtonsDown tells us which buttons were pressed in this loop
			// this is a "one shot" state which will not fire again until the button has been released
			if (WPAD_ButtonsDown(0) != 0) {
				printf("\x1b[%d;17H\x1b[30m*", (space * option) + 4);
				switch (WPAD_ButtonsDown(0)) {
					case WPAD_BUTTON_HOME:
						exit(0);
						break;
					case WPAD_BUTTON_UP:
						option--;
						if (option < 0) option = PATCH_COUNT+1;
						break;
					case WPAD_BUTTON_DOWN:
						option++;
						if (option > PATCH_COUNT+1) option = 0;
						break;
					case WPAD_BUTTON_A:
						if (option == PATCH_COUNT+1) exit(0);
						if (option == PATCH_COUNT) save_menu();
						printf("\x1b[32m\x1b[2J\x1b[2;2H");
						install = install_patch(&ptch[option]);
						patch = 0;
						break;
					case WPAD_BUTTON_B:
						if (option == PATCH_COUNT+1) exit(0);
						if (option == PATCH_COUNT) save_menu();
						printf("\x1b[32m\x1b[2J\x1b[2;2H");
						install = remove_patch(&ptch[option]);
						patch = 0;
						break;
				}
				printf("\x1b[%d;17H\x1b[32m*", (space * option) + 4);
			}
			VIDEO_WaitVSync();
		}
	}
	return 0;
}
